/**
 * @class kClipInfo
 * @brief Info about a hitscan collision. Used by kWorldComponent::HitScan
 */
 
class kClipInfo
{
public:

	/**
	* @brief Handle pointer to colliders WorldComponent (null if none was collided)
	*/
	kWorldComponent@ pContactCollider;
	
	/**
	* @brief Returns the 0.0 - 1.0 range of the point of intersection from start to end trace. (If fraction is == 1.0 then no intersection occured.)
	*/
	float fraction;
	
	/**
	* @brief Specifies the type of intersection
	*/
	EnumClipFlags clipResult;

	/**
	* @brief Returns the vector that intersected the collided geometry
	*/
	kVec3 vInterceptVector;

	/**
	* @brief Returns the normalized vector of the collided surface
	*/
	kVec3 vContactNormal;
	
	/**
	* @brief The RegionID where contact was made
	*/
	int contactRegion;

	int impactType;
	bool bHitWater;
	int16 wBoneType;
	int16 wBoneID;
};
