/**
 * @class kDamageInfo
 * @brief Info about Damage to be inflicted or was inflicted
 */
 
class kDamageInfo
{
public:

	/**
	* @brief The amount of damage
	*/
	float hits;
	
	/**
	* @brief The particle that is causing this damage. Null if there was no particle.
	*/
	kParticle@ particle;
	
	/**
	* @brief The actor that caused the damage (same as source except this property doesn't seem to be used). Null if there was no inflictor.
	*/
	kActor@ inflictor;
	
	/**
	* @brief The actor that caused the damage. Null if there was no source actor.
	*/
	kActor@ source;
	
	/**
	* @brief The actor that is taking the damage.
	*/
	kActor@ target;
	
	/**
	* @brief The type of bone that was damaged
	*/
	uint boneFlags;
	
	/**
	* @brief The boneID or nodeID on the skinnedmesh that was damaged
	*/
	int boneID;
	
	/**
	* @brief The type of damage that this is
	*/
	EnumDamageFlags flags; //EnumDamageFlags
	
	/**
	* @brief The radius effect
	*/
	float radius;
	
	bool opEquals(const ?&in);
	const bool opEquals(const ref &in);
};
