/**
 * @class kEvent
 * @brief Run an "Action"
 */
class kEvent
{
public:

	/**
	 * @brief Runs a certain action using \a actionID on the \a source and/or \a target actors or at the \a origin position with up to 8 arguments to pass to the action \n
	 * Example of unblocking a region where the \a source actor is located.
	 * @code{.cpp}
	 * Event.RunAction(self, null, ACTION_UNBLOCK, Math::vecZero);
	 * @endcode
	 */
	void RunAction(kActor@ source, kActor@ target, const int actionID, const kVec3&in origin, const float arg1 = 0, const float arg2 = 0, const float arg3 = 0, const float arg4 = 0, const float arg5 = 0, const float arg6 = 0, const float arg7 = 0, const float arg8 = 0);
};
